
#include "bits/bit-necklace.h"

#include "fxtiomanip.h"
#include "fxttypes.h"  // ulong

#include "demo/nextarg.h" // NXARG()

#include "bits/printbin.h"
#include "bits/bit2pow.h"

//% Binary necklaces and Lyndon words: CAT generation.


//#define TIMING // uncomment to disable printing

int
main(int argc, char **argv)
{
    ulong n = 8;
    NXARG(n, "Number of bits");

    bit_necklace bn(n);

    ulong nct = 0;  // count necklaces (prime strings)
    ulong lct = 0;  // count Lyndon words
    do
    {
        ++nct;
#ifndef TIMING
        cout << setw(4) << nct << ": ";
        print_bin("  ", bn.data(), n);
        cout << "  " << setw(2) << bn.period();
        if ( bn.is_lyndon_word() )
        {
            ++lct;
            cout << "  L";
        }
        cout << endl;
#endif  // TIMING
    }
    while ( bn.next() );

//    cout << " n = " << n << ":  ";
    cout << "  # necklaces=" << nct;
#ifndef TIMING
    cout << "  # Lyndon words=" << lct;
#endif  // TIMING
    cout << endl;


    return 0;
}
// -------------------------

/*
Timing:

 time ./bin 32
  # necklaces=134219796
./bin 32  4.15s user 0.03s system 99% cpu 4.181 total
  ==> 134219796/4.15 == 32,342,119 necklaces per second

*/

/// Emacs:
/// Local Variables:
/// MyRelDir: "demo/bits"
/// makefile-dir: "../../"
/// make-target: "1demo DSRC=demo/bits/bit-necklace-demo.cc"
/// End:

