
#include "bits/bitlex.h"
#include "bits/printbitset.h"

#include "fxttypes.h"
#include "fxtiomanip.h"
#include "bits/printbin.h"
#include "bits/bitsperlong.h"

//#include "bits/graycode.h"
//#include "bits/bitcount.h"

#include "demo/nextarg.h"


//% Generating binary words in subset-lexicographic order.

//#define TIMING // uncomment to disable printing

int
main(int argc, char **argv)
{
    ulong n = 5;
    NXARG(n, "n-bit binary words");
    ulong m = 1UL<<n;
    bool bq = 0;
    NXARG(bq, "Whether to also print backwards list");
    const ulong rq = n;

#ifndef TIMING
    ulong x = 1UL<<(n-1);  // first subset
    ulong ct = 0;
    do
    {
        ++ct;
        cout  << setw(4) << ct << ":";
        print_bin("  ", x, n);
        cout << "  = " << setw(2) << x;
//        cout << "   b=" << setw(2) << bit_count(x);
        print_bit_set("  ", x, rq);
        cout << endl;
    }
    while ( (x=next_lexrev(x)) );


    cout << endl;

    if ( bq )
    {
//        cout << " ... and backward (fixed point marked with '*'):" << endl;
        ct = 1;
        while ( (x = prev_lexrev(x)) < m )
        {
            cout  << setw(4) << ct << ":";
            print_bin("  ", x, n);
            cout << "  = " << setw(2) << x;
//            cout << "   b=" << setw(2) << bit_count(x);

//            if ( is_lexrev_fixed_point(x) )  cout << " *";  else  cout << "  ";

            print_bit_set("  ", x, rq);

//            print_bin("  ", negidx2lexrev(ct), n+1);  // == x
//            ulong z = x ^ next_lexrev(x);
//            print_bin("  ", z, n+1);
            ++ct;
            cout << endl;
        }
    }
#else

//    ulong x = 0;  while ( (x=prev_lexrev(x))<m )  { ; }
    ulong x = (1UL<<n)-1;  while ( (x=next_lexrev(x)) )  { ; }

#endif

    return  0;
}
// -------------------------

/*
Timing:
 time ./bin 30  // next()
arg 1: 30 == n  [n-bit binary words]  default=5
./bin 30  4.77s user 0.02s system 99% cpu 4.790 total
 ==> 2^30/4.77 == 225,103,107 per second

 time ./bin 30  // prev()
./bin 30  4.30s user 0.02s system 99% cpu 4.328 total
 ==> 2^30/4.30 == 249,707,400
*/

/// Emacs:
/// Local Variables:
/// MyRelDir: "demo/bits"
/// makefile-dir: "../../"
/// make-target: "1demo DSRC=demo/bits/bitlex-demo.cc"
/// End:

