
#include "bits/bitsubset-gray.h"
// demo-include "bits/bitsubset.h"

#include "bits/printbin.h"
#include "bits/bit2pow.h"  // ld()

#include "fxttypes.h"
#include "fxtio.h"

#include "demo/nextarg.h"
#include "jjassert.h"

#include <cstdlib>  // strtoul()

//% Generating all bit-subsets in Gray code order.

const char *vv[] =
{
    "00011010",
    "00010000",
    "00001111",
    "10001001",
    "00000000"
};
// -------------------------

#define CHECK() { ulong w = S.current();  S.prev();  S.next();  jjassert( w==S.current() ); }

static void show_subsets(ulong v)
{
    cout << endl;
    cout << "v=" << v;
    print_bin( " == ", v, ld(v)+1, "01");
    cout << endl;

    bit_subset_gray S(v);
    do
    {
        print_bin("", S.next(), 8);
        cout << endl;
        CHECK();
    }
    while ( S.current() );

    CHECK();

    cout << "----" << endl;
    do
    {
        print_bin("", S.prev(), 8);
        cout << endl;
        CHECK();
    }
    while ( S.current() );

    cout << endl;
}
// -------------------------


int
main(int argc, char **argv)
{
    ulong w = 0;
    NXARG(w, "word whose bit-subsets are shown (0==> some default words)");

    if ( w )  show_subsets(w);
    else
    {
        for (ulong i=0; i<sizeof(vv)/sizeof(vv[0]); ++i)
        {
            ulong v = strtoul(vv[i], 0, 2);
            show_subsets(v);
        }
    }

    return 0;
}
// -------------------------


/// Emacs:
/// Local Variables:
/// MyRelDir: "demo/bits"
/// makefile-dir: "../../"
/// make-target: "1demo DSRC=demo/bits/bitsubset-gray-demo.cc"
/// End:
