
#include "comb/ruler-func.h"

#include "comb/comb-print.h"

#include "demo/nextarg.h"
#include "fxttypes.h"

#include "fxtio.h"

//% Ruler function sequence.

//#define TIMING // uncomment to disable printing



int
main(int argc, char **argv)
{
    ulong n = 6;
    NXARG(n, "Stop when n is encountered in the sequence (==>2**n elements).");

    ruler_func R(n);

    ulong ct = 0;
#ifdef TIMING
    do  { ++ct; }  while ( n!=R.next() );
#else

    ulong j;
    do
    {
        ++ct;
        j = R.next();
        cout << " " << j;
//        print_vec("    ", R.f_, n);  cout << endl;
        if ( j>3 )  cout << endl;
    }
    while ( j!=n );
    cout << endl;

#endif
    cout << " ct=" << ct << endl;

    return 0;
};
// -------------------------


/*
Timing:

 time ./bin 30
arg 1: 30 == n  [Size of the set]  default=6
 ct=1073741824
./bin 30  3.67s user 0.02s system 99% cpu 3.694 total
 ==> 2^30/3.67 == 292,572,704 per second

// with RULER_FUNC_MAX_ARRAY_LEN defined:
./bin 30  4.28s user 0.03s system 99% cpu 4.311 total
 ==> 2^30/4.28 == 250,874,257 per second

*/


/// Emacs:
/// Local Variables:
/// MyRelDir: "demo/comb"
/// makefile-dir: "../../"
/// make-target: "1demo DSRC=demo/comb/ruler-func-demo.cc"
/// End:
